import SessionManagerFactory from './SessionManagerFactory.ts'
import MemorySessionManager from './MemorySessionManager.ts'

/**
 * Session manager factory that produces memory-based session managers.
 * @extends SessionManagerFactory
 */
export default class MemorySessionManagerFactory extends SessionManagerFactory {
    produce(dependencies: any[], parameters: any[]): any {
        return new MemorySessionManager()
    }
}
