import {AsyncCollection} from '../../../../../lib/src/collection/AsyncCollection.ts'
import {ResultIterable} from './ResultIterable.ts'
import {Collection} from '../../../../../lib/src/collection/Collection.ts'

/**
 * Asynchronous collection representing the results of a query.
 * @extends AsyncCollection
 */
export class ResultCollection<T> extends AsyncCollection<T> {
    constructor(
        executable: ResultIterable<T>,
        chunk_size: number = 1000
    ) {
        super(executable, chunk_size)
    }
    
    then(func?: (items: Collection<T>) => any) {
        if ( func ) {
            this.collect().then((items: Collection<T>) => func(items))
        } else {
            return new Promise(res => [
                this.collect().then((items: Collection<T>) => res(items))
            ])
        }
    }
}
